diff -rupN seq24-rev48 adding win32/src/seq24.cpp seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/seq24.cpp
--- seq24-rev48 adding win32/src/seq24.cpp	2009-05-20 20:30:47.125000000 -0500
+++ seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/seq24.cpp	2009-05-20 20:30:55.796875000 -0500
@@ -45,9 +45,11 @@ option long_options[] = {
     {"file",     required_argument, 0, 'f'},
     {"help",     0, 0, 'h'},
     {"showmidi",     0, 0, 's'},
+    {"show_keys",     0, 0, 'k' },
     {"stats",     0, 0, 'S' },
     {"priority", 0, 0, 'p' },
     {"ignore",required_argument, 0, 'i'},
+    {"interaction_method",required_argument, 0, 'x'},
     {"jack_transport",0, 0, 'j'},
     {"jack_master",0, 0, 'J'},
     {"jack_master_cond",0,0,'C'},
@@ -71,6 +73,7 @@ Glib::ustring last_used_dir ="/";
 std::string config_filename = ".seq24rc";
 std::string user_filename = ".seq24usr";
 bool global_print_keys = false;
+interaction_method_e global_interactionmethod = e_seq24_interaction;
 
 bool global_with_jack_transport = false;
 bool global_with_jack_master = false;
@@ -183,6 +186,7 @@ main (int argc, char *argv[])
                 printf( "    --priority : runs higher priority with FIFO scheduler (must be root)\n" );
                 printf( "    --pass_sysex : passes any incoming sysex messages to all outputs \n" );
                 printf( "    --show_keys : prints pressed key value\n" );
+                printf( "    --interaction_method <number>: see .seq24rc for methods to use\n" );
                 printf( "    --jack_transport : seq24 will sync to jack transport\n" );
                 printf( "    --jack_master : seq24 will try to be jack master\n" );
                 printf( "    --jack_master_cond : jack master will fail if there is already a master\n" );
@@ -249,6 +253,10 @@ main (int argc, char *argv[])
                 global_device_ignore_num = atoi( optarg );
                 break;
                 
+            case 'x':
+                global_interactionmethod = (interaction_method_e)atoi( optarg );
+                break;
+
                 
             default:
                 break;
@@ -302,3 +310,40 @@ main (int argc, char *argv[])
 
     return 0;
 }
+
+
+/* declared in globals.h */
+char* key2text( unsigned long int val )
+{
+    unsigned long int s[] = {GDK_Insert, GDK_Escape, GDK_Return, GDK_Delete,
+                          GDK_BackSpace, GDK_Pause, GDK_Break, GDK_Tab, GDK_Scroll_Lock,
+                          GDK_Left, GDK_Right, GDK_Up, GDK_Down, GDK_Page_Up, GDK_Page_Down,
+                          GDK_Break, GDK_Num_Lock, GDK_F1, GDK_F2, GDK_F3, GDK_F4, GDK_F5,
+                          GDK_F6, GDK_F7, GDK_F8, GDK_F9, GDK_F10, GDK_F11, GDK_F12,
+                          GDK_Shift_L, GDK_Shift_R, GDK_Control_L, GDK_Control_R,
+                          GDK_Caps_Lock, GDK_Alt_L, GDK_Alt_R, GDK_Home, GDK_End, '\n', '\t', 0 };
+    char* str[] = {"Ins", "Esc", "Ret", "Del",
+                   "Bck", "Paus", "Brk", "Tab", "ScLk",
+                   "<-", "->", "Up", "Dn", "PgUp", "PgDn",
+                   "Brk", "NmLk", "F1", "F2", "F3", "F4", "F5",
+                   "F6", "F7", "F8", "F9", "F10", "F11", "F12",
+                   "ShL", "ShR", "CtlL", "CtlR",
+                   "Caps", "AltL", "AltR", "Home", "End", "Ret", "Tab", 0 };
+    unsigned long int* s2 = s;
+    char** str2 = str;
+    while (*s2 != 0) { if (val == s2[0]) return str2[0];  s2++; str2++; }
+    //for ( int x = '!'; x <= '~'; ++x) printf( "ascii: %d  '%c'\n", x, (char)x);
+
+    static char buf[16][16];
+    static int rotate = 0; //lets us use this in iostreams for example...
+    rotate = (rotate + 1) % 16;
+    strcpy( buf[rotate], "??" );
+
+    //printf( "%d %d %d %d - ", val, ' ' <= val, val <= '~', *s2 );
+    if (*s2 == 0 && ' ' <= val && val <= '~')
+    {
+        sprintf( buf[rotate], "'%c'", (char)val );
+    }
+    //printf( "  ret: %s\n", buf[rotate] );
+    return buf[rotate];
+}
diff -rupN seq24-rev48 adding win32/src/seqedit.cpp seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/seqedit.cpp
--- seq24-rev48 adding win32/src/seqedit.cpp	2009-05-20 20:30:47.265625000 -0500
+++ seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/seqedit.cpp	2009-05-20 20:30:55.937500000 -0500
@@ -48,6 +48,13 @@
 #include "tools.xpm"
 #include "seq-editor.xpm"
 
+// tooltip helper, for old vs new gtk...
+#if GTK_MINOR_VERSION >= 12
+#   define add_tooltip( obj, text ) obj->set_tooltip_text( text);
+#else
+#   define add_tooltip( obj, text ) m_tooltips->set_tip( *obj, text );
+#endif
+
 int seqedit::m_initial_zoom = 2;
 int seqedit::m_initial_snap = c_ppqn / 4;
 int seqedit::m_initial_note_length = c_ppqn / 4;
@@ -225,31 +232,31 @@ seqedit::seqedit( sequence *a_seq, 
     m_toggle_play->add(  *manage( new Image(Gdk::Pixbuf::create_from_xpm_data( play_xpm ))));
     m_toggle_play->signal_clicked().connect(
             mem_fun( *this, &seqedit::play_change_callback));
-    m_tooltips->set_tip( *m_toggle_play, "Sequence dumps data to midi bus." );
+    add_tooltip( m_toggle_play, "Sequence dumps data to midi bus." );
     
     m_toggle_record = manage( new ToggleButton(  ));
     m_toggle_record->add( *manage( new Image(Gdk::Pixbuf::create_from_xpm_data( rec_xpm ))));
     m_toggle_record->signal_clicked().connect(
             mem_fun( *this, &seqedit::record_change_callback));
-    m_tooltips->set_tip( *m_toggle_record, "Records incoming midi data." );
+    add_tooltip( m_toggle_record, "Records incoming midi data." );
 
     m_toggle_q_rec = manage( new ToggleButton(  ));
     m_toggle_q_rec->add( *manage( new Image(Gdk::Pixbuf::create_from_xpm_data( q_rec_xpm ))));
     m_toggle_q_rec->signal_clicked().connect(
             mem_fun( *this, &seqedit::q_rec_change_callback));
-    m_tooltips->set_tip( *m_toggle_q_rec, "Quantized Record." );
+    add_tooltip( m_toggle_q_rec, "Quantized Record." );
 
     m_button_rec_vol = manage( new Button());
     m_button_rec_vol->add( *manage( new Label("Vol")));
     m_button_rec_vol->signal_clicked().connect(
             sigc::bind<Menu *>( mem_fun( *this, &seqedit::popup_menu), m_menu_rec_vol  ));
-    m_tooltips->set_tip( *m_button_rec_vol, "Select recording volume" );
+    add_tooltip( m_button_rec_vol, "Select recording volume" );
 
     m_toggle_thru = manage( new ToggleButton(  ));
     m_toggle_thru->add( *manage( new Image(Gdk::Pixbuf::create_from_xpm_data( thru_xpm ))));
     m_toggle_thru->signal_clicked().connect(
             mem_fun( *this, &seqedit::thru_change_callback));
-    m_tooltips->set_tip( *m_toggle_thru, "Incoming midi data passes "
+    add_tooltip( m_toggle_thru, "Incoming midi data passes "
             "thru to sequences midi bus and channel." );
 
     m_toggle_play->set_active( m_seq->get_playing());
@@ -689,7 +696,7 @@ seqedit::fill_top_bar( void )
     m_button_bpm->signal_clicked().connect(
             sigc::bind<Menu *>( mem_fun( *this, &seqedit::popup_menu),
                 m_menu_bpm  ));
-    m_tooltips->set_tip( *m_button_bpm, "Time Signature. Beats per Measure" );
+    add_tooltip( m_button_bpm, "Time Signature. Beats per Measure" );
     m_entry_bpm = manage( new Entry());
     m_entry_bpm->set_width_chars(2);
     m_entry_bpm->set_editable( false );
@@ -705,7 +712,7 @@ seqedit::fill_top_bar( void )
     m_button_bw->signal_clicked().connect(
             sigc::bind<Menu *>( mem_fun( *this, &seqedit::popup_menu),
                 m_menu_bw  ));
-    m_tooltips->set_tip( *m_button_bw, "Time Signature. Length of Beat" );
+    add_tooltip( m_button_bw, "Time Signature. Length of Beat" );
     m_entry_bw = manage( new Entry());
     m_entry_bw->set_width_chars(2);
     m_entry_bw->set_editable( false );
@@ -719,7 +726,7 @@ seqedit::fill_top_bar( void )
     m_button_length->signal_clicked().connect(
             sigc::bind<Menu *>( mem_fun( *this, &seqedit::popup_menu),
                 m_menu_length  ));
-    m_tooltips->set_tip( *m_button_length, "Sequence length in Bars." );
+    add_tooltip( m_button_length, "Sequence length in Bars." );
     m_entry_length = manage( new Entry());
     m_entry_length->set_width_chars(2);
     m_entry_length->set_editable( false );
@@ -735,7 +742,7 @@ seqedit::fill_top_bar( void )
     m_button_bus->add( *manage( new Image(Gdk::Pixbuf::create_from_xpm_data( bus_xpm  ))));
     m_button_bus->signal_clicked().connect(
             mem_fun( *this, &seqedit::popup_midibus_menu));
-    m_tooltips->set_tip( *m_button_bus, "Select Output Bus." );
+    add_tooltip( m_button_bus, "Select Output Bus." );
 
     m_entry_bus = manage( new Entry());
     m_entry_bus->set_max_length(60);
@@ -750,7 +757,7 @@ seqedit::fill_top_bar( void )
     m_button_channel->add( *manage( new Image(Gdk::Pixbuf::create_from_xpm_data( midi_xpm  ))));
     m_button_channel->signal_clicked().connect(
             mem_fun( *this, &seqedit::popup_midich_menu ));
-    m_tooltips->set_tip( *m_button_channel, "Select Midi channel." );
+    add_tooltip( m_button_channel, "Select Midi channel." );
     m_entry_channel = manage( new Entry());
     m_entry_channel->set_width_chars(2);
     m_entry_channel->set_editable( false );
@@ -764,7 +771,7 @@ seqedit::fill_top_bar( void )
     m_button_undo->add( *manage( new Image(Gdk::Pixbuf::create_from_xpm_data( undo_xpm  ))));
     m_button_undo->signal_clicked().connect(
             mem_fun( *this, &seqedit::undo_callback));
-    m_tooltips->set_tip( *m_button_undo, "Undo." );
+    add_tooltip( m_button_undo, "Undo." );
  
     m_hbox2->pack_start( *m_button_undo , false, false );
     
@@ -773,7 +780,7 @@ seqedit::fill_top_bar( void )
     m_button_redo->add( *manage( new Image(Gdk::Pixbuf::create_from_xpm_data( redo_xpm  ))));
     m_button_redo->signal_clicked().connect(
             mem_fun( *this, &seqedit::redo_callback));
-    m_tooltips->set_tip( *m_button_redo, "Redo." );
+    add_tooltip( m_button_redo, "Redo." );
  
     m_hbox2->pack_start( *m_button_redo , false, false );
     
@@ -782,7 +789,7 @@ seqedit::fill_top_bar( void )
     m_button_quanize->add( *manage( new Image(Gdk::Pixbuf::create_from_xpm_data( quanize_xpm  ))));
     m_button_quanize->signal_clicked().connect(
             sigc::bind(mem_fun(*this, &seqedit::do_action), quantize_notes, 0));
-    m_tooltips->set_tip( *m_button_quanize, "Quantize Selection." );
+    add_tooltip( m_button_quanize, "Quantize Selection." );
  
     m_hbox2->pack_start( *m_button_quanize , false, false );
 
@@ -804,7 +811,7 @@ seqedit::fill_top_bar( void )
     m_button_snap->signal_clicked().connect(
             sigc::bind<Menu *>( mem_fun( *this, &seqedit::popup_menu),
                 m_menu_snap  ));
-    m_tooltips->set_tip( *m_button_snap, "Grid snap." );
+    add_tooltip( m_button_snap, "Grid snap." );
     m_entry_snap = manage( new Entry());
     m_entry_snap->set_width_chars(5);
     m_entry_snap->set_editable( false );
@@ -818,7 +825,7 @@ seqedit::fill_top_bar( void )
     m_button_note_length->signal_clicked().connect(
             sigc::bind<Menu *>( mem_fun( *this, &seqedit::popup_menu),
                 m_menu_note_length  ));
-    m_tooltips->set_tip( *m_button_note_length, "Note Length." );
+    add_tooltip( m_button_note_length, "Note Length." );
     m_entry_note_length = manage( new Entry());
     m_entry_note_length->set_width_chars(5);
     m_entry_note_length->set_editable( false );
@@ -833,7 +840,7 @@ seqedit::fill_top_bar( void )
     m_button_zoom->signal_clicked().connect(
             sigc::bind<Menu *>( mem_fun( *this, &seqedit::popup_menu),
                 m_menu_zoom  ));
-    m_tooltips->set_tip( *m_button_zoom, "Zoom. Pixels to Ticks" );
+    add_tooltip( m_button_zoom, "Zoom. Pixels to Ticks" );
     m_entry_zoom = manage( new Entry());
     m_entry_zoom->set_width_chars(4);
     m_entry_zoom->set_editable( false );
@@ -850,7 +857,7 @@ seqedit::fill_top_bar( void )
     m_button_key->signal_clicked().connect(
             sigc::bind<Menu *>( mem_fun( *this, &seqedit::popup_menu),
                 m_menu_key  ));
-    m_tooltips->set_tip( *m_button_key, "Key of Sequence" );
+    add_tooltip( m_button_key, "Key of Sequence" );
     m_entry_key = manage( new Entry());
     m_entry_key->set_width_chars(5);
     m_entry_key->set_editable( false );
@@ -864,7 +871,7 @@ seqedit::fill_top_bar( void )
     m_button_scale->signal_clicked().connect(
             sigc::bind<Menu *>( mem_fun( *this, &seqedit::popup_menu),
                 m_menu_scale  ));
-    m_tooltips->set_tip( *m_button_scale, "Musical Scale" );
+    add_tooltip( m_button_scale, "Musical Scale" );
     m_entry_scale = manage( new Entry());
     m_entry_scale->set_width_chars(5);
     m_entry_scale->set_editable( false );
@@ -879,7 +886,7 @@ seqedit::fill_top_bar( void )
     m_button_sequence->add( *manage( new Image(Gdk::Pixbuf::create_from_xpm_data( sequences_xpm  ))));
     m_button_sequence->signal_clicked().connect(
             mem_fun( *this, &seqedit::popup_sequence_menu));
-    m_tooltips->set_tip( *m_button_sequence, "Background Sequence" );
+    add_tooltip( m_button_sequence, "Background Sequence" );
     m_entry_sequence = manage( new Entry());
     m_entry_sequence->set_width_chars(14);
     m_entry_sequence->set_editable( false );
diff -rupN seq24-rev48 adding win32/src/seqevent.cpp seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/seqevent.cpp
--- seq24-rev48 adding win32/src/seqevent.cpp	2009-05-20 20:30:47.375000000 -0500
+++ seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/seqevent.cpp	2009-05-20 20:30:56.093750000 -0500
@@ -57,7 +57,6 @@ seqevent::seqevent(sequence *a_seq,
     m_moving    = false;
     m_moving_init = false;
     m_growing   = false;
-    m_adding    = false;
     m_paste     = false;
     m_painting  = false;
     
@@ -559,203 +558,409 @@ seqevent::convert_t( long a_ticks, int *
 }
 
 
-/* popup menu calls this */
+
+
+
+bool 
+seqevent::on_button_press_event(GdkEventButton* a_ev)
+{
+    switch (global_interactionmethod)
+    {
+        case e_fruity_interaction:
+             return m_fruity_interaction.on_button_press_event(a_ev, *this);
+        case e_seq24_interaction:
+             return m_seq24_interaction.on_button_press_event(a_ev, *this);
+    }
+    return false;
+}
+
 void
-seqevent::set_adding( bool a_adding )
+seqevent::drop_event( long a_tick )
 {
-    if ( a_adding ){
- 
-	get_window()->set_cursor(  Gdk::Cursor( Gdk::PENCIL ));
-	m_adding = true;
+
+    unsigned char status = m_status;
+    unsigned char d0 = m_cc;
+    unsigned char d1 = 0x40;
+
+    if ( m_status == EVENT_AFTERTOUCH )
+        d0 = 0;
+
+    if ( m_status == EVENT_PROGRAM_CHANGE )
+        d0 = 0; /* d0 == new patch */
+
+    if ( m_status == EVENT_CHANNEL_PRESSURE )
+        d0 = 0x40; /* d0 == pressure */
+
+    if ( m_status == EVENT_PITCH_WHEEL )
+        d0 = 0;
+
+    m_seq->add_event( a_tick, 
+            status,
+            d0,
+            d1, true );
+}
+
+
+bool 
+seqevent::on_button_release_event(GdkEventButton* a_ev)
+{
+    switch (global_interactionmethod)
+    {
+        case e_fruity_interaction:
+             return m_fruity_interaction.on_button_release_event(a_ev, *this);
+        case e_seq24_interaction:
+             return m_seq24_interaction.on_button_release_event(a_ev, *this);
     }
-    else {
+    return false;
+}
+
+
 
-	get_window()->set_cursor( Gdk::Cursor( Gdk::LEFT_PTR ));
-	m_adding = false;
+bool
+seqevent::on_motion_notify_event(GdkEventMotion* a_ev)
+{
+    switch (global_interactionmethod)
+    {
+        case e_fruity_interaction:
+             return m_fruity_interaction.on_motion_notify_event(a_ev, *this);
+        case e_seq24_interaction:
+             return m_seq24_interaction.on_motion_notify_event(a_ev, *this);
     }
+    return false;
+}
+
+
+
+/* performs a 'snap' on y */
+void 
+seqevent::snap_y( int *a_y )
+{
+    *a_y = *a_y - (*a_y % c_key_y);
+}
+
+/* performs a 'snap' on x */
+void 
+seqevent::snap_x( int *a_x )
+{
+    //snap = number pulses to snap to
+    //m_zoom = number of pulses per pixel
+    //so snap / m_zoom  = number pixels to snap to
+    int mod = (m_snap / m_zoom);
+    if ( mod <= 0 )
+        mod = 1;
+    
+    *a_x = *a_x - (*a_x % mod );
+  
 }
 
 
 bool 
-seqevent::on_button_press_event(GdkEventButton* a_ev)
+seqevent::on_focus_in_event(GdkEventFocus*)
 {
-    int x,w,numsel;
+    set_flags(Gtk::HAS_FOCUS);
+    return false;
+}
+
+bool 
+seqevent::on_focus_out_event(GdkEventFocus*)
+{
+    unset_flags(Gtk::HAS_FOCUS);
+    return false;
+}
+
+bool
+seqevent::on_key_press_event(GdkEventKey* a_p0)
+{
+    bool ret = false;
+
+    if ( a_p0->type == GDK_KEY_PRESS ){
+
+        if ( a_p0->keyval ==  GDK_Delete || a_p0->keyval == GDK_BackSpace ){
+
+            m_seq->push_undo();
+            m_seq->mark_selected();
+            m_seq->remove_marked();
+            ret = true;
+        }
+
+        if ( a_p0->state & GDK_CONTROL_MASK ){
+
+            /* cut */
+            if ( a_p0->keyval == GDK_x || a_p0->keyval == GDK_X ){
+
+                m_seq->copy_selected();
+                m_seq->mark_selected();
+                m_seq->remove_marked();
+
+                ret = true;
+            }
+            /* copy */
+            if ( a_p0->keyval == GDK_c || a_p0->keyval == GDK_C ){
+
+                m_seq->copy_selected();
+                ret = true;
+            }
+            /* paste */
+            if ( a_p0->keyval == GDK_v || a_p0->keyval == GDK_V ){
+
+                start_paste();
+                ret = true;
+            }
+            /* Undo */
+            if ( a_p0->keyval == GDK_z || a_p0->keyval == GDK_Z ){
+
+                m_seq->pop_undo();
+                ret = true;
+            }
+         }
+    }
+
+    if ( ret == true ){
+
+        redraw();
+        m_seq->set_dirty();
+        return true;
+    }
+    else
+
+        return false;
+}
+
+
+
+
+
+//////////////////////////
+// interaction methods
+//////////////////////////
+
+
+void FruitySeqEventInput::updateMousePtr(seqevent& ths)
+{
+    // context sensitive mouse
+    long tick_s, tick_w, tick_f, pos;
+    ths.convert_x( ths.m_current_x, &tick_s );
+    ths.convert_x( c_eventevent_x, &tick_w  );
+    tick_f = tick_s + tick_w;
+    if ( tick_s < 0 )
+        tick_s = 0; // clamp to 0
+
+
+    if (m_is_drag_pasting || ths.m_selecting || ths.m_moving || ths.m_paste)
+    {
+        ths.get_window()->set_cursor( Gdk::Cursor( Gdk::LEFT_PTR ));
+    }
+    else if (ths.m_seq->intersectEvents( tick_s, tick_f, ths.m_status, pos ))
+    {
+        ths.get_window()->set_cursor( Gdk::Cursor( Gdk::CENTER_PTR ));
+    }
+    else
+    {
+        ths.get_window()->set_cursor( Gdk::Cursor( Gdk::PENCIL ));
+    }
+}
+
+
+bool FruitySeqEventInput::on_button_press_event(GdkEventButton* a_ev, seqevent& ths)
+{
+     int x,w,numsel;
 
     long tick_s;
     long tick_f;
     long tick_w;
 
-    convert_x( c_eventevent_x, &tick_w  );
+    ths.convert_x( c_eventevent_x, &tick_w  );
 
     /* if it was a button press */
 
     /* set values for dragging */
-    m_drop_x = m_current_x = (int) a_ev->x + m_scroll_offset_x;
+    ths.m_drop_x = ths.m_current_x = (int) a_ev->x + ths.m_scroll_offset_x;
 
     /* reset box that holds dirty redraw spot */
-    m_old.x = 0;
-    m_old.y = 0;
-    m_old.width = 0;
-    m_old.height = 0;
-
-    if ( m_paste ){
-
-        snap_x( &m_current_x );
-        convert_x( m_current_x, &tick_s );
-        m_paste = false;
-        m_seq->push_undo();
-        m_seq->paste_selected( tick_s, 0 );
+    ths.m_old.x = 0;
+    ths.m_old.y = 0;
+    ths.m_old.width = 0;
+    ths.m_old.height = 0;
+
+    if ( ths.m_paste ){
+
+        ths.snap_x( &ths.m_current_x );
+        ths.convert_x( ths.m_current_x, &tick_s );
+        ths.m_paste = false;
+        ths.m_seq->push_undo();
+        ths.m_seq->paste_selected( tick_s, 0 );
 
     } else {
 
         /*      left mouse button     */
-        if ( a_ev->button == 1 ){ 
-
+        if ( a_ev->button == 1 )
+        {
             /* turn x,y in to tick/note */
-            convert_x( m_drop_x, &tick_s );
+            ths.convert_x( ths.m_drop_x, &tick_s );
 
             /* shift back a few ticks */
-            tick_f = tick_s + (m_zoom);
+            tick_f = tick_s + (ths.m_zoom);
             tick_s -= (tick_w);
 
-            if ( tick_s < 0 ) 
+            if ( tick_s < 0 )
                 tick_s = 0;
 
-            if ( m_adding )
+            if ( ! ths.m_seq->select_events( tick_s, tick_f,
+                            ths.m_status, ths.m_cc, sequence::e_would_select ) &&
+                 !(a_ev->state & GDK_CONTROL_MASK) )
             {
-                m_painting = true;
+                ths.m_painting = true;
 
-                snap_x( &m_drop_x );
+                ths.snap_x( &ths.m_drop_x );
                 /* turn x,y in to tick/note */
-                convert_x( m_drop_x, &tick_s );
-                /* add note, length = little less than snap */
+                ths.convert_x( ths.m_drop_x, &tick_s );
 
-                if ( ! m_seq->select_events( tick_s, tick_f,
-                            m_status, m_cc, sequence::e_would_select ))
+                /* add note, length = little less than snap */
+                if ( ! ths.m_seq->select_events( tick_s, tick_f,
+                            ths.m_status, ths.m_cc, sequence::e_would_select ))
                 {
-                    m_seq->push_undo();
-                    drop_event( tick_s );
+                    ths.m_seq->push_undo();
+                    ths.drop_event( tick_s );
                 }
 
             }
             else /* selecting */
             {
-                if ( ! m_seq->select_events( tick_s, tick_f,
-                            m_status, m_cc, sequence::e_is_selected ))
+                if ( ! ths.m_seq->select_events( tick_s, tick_f,
+                            ths.m_status, ths.m_cc, sequence::e_is_selected ))
                 {
-                    if ( ! (a_ev->state & GDK_CONTROL_MASK) )
+                    // if clicking event...
+                    if (ths.m_seq->select_events( tick_s, tick_f,
+                            ths.m_status, ths.m_cc, sequence::e_would_select ) )
                     {
-                        m_seq->unselect();
-                    }
-
-                    numsel = m_seq->select_events( tick_s, tick_f,
-                            m_status,
-                            m_cc, sequence::e_select_one );
-
-                    /* if we didnt select anyhing (user clicked empty space)
-                       unselect all notes, and start selecting */
-
-                    /* none selected, start selection box */
-                    if ( numsel == 0 )
-                    { 
-                        m_selecting = true;
+                        if ( ! (a_ev->state & GDK_CONTROL_MASK) )
+                           ths.m_seq->unselect();
                     }
+                    // if clicking empty space ...
                     else
                     {
-                        /// needs update
+                        // ... unselect all if ctrl-shift not held
+                        if (! ((a_ev->state & GDK_CONTROL_MASK) &&
+                               (a_ev->state & GDK_SHIFT_MASK)) )
+                           ths.m_seq->unselect();
                     }
+
+                    /* on direct click select only one event */
+                    numsel = ths.m_seq->select_events( tick_s, tick_f,
+                            ths.m_status,
+                            ths.m_cc, sequence::e_select_one );
+
+                    // prevent deselect in button_release()
+                    if (numsel)
+                       m_justselected_one = true;
+
+                    // if nothing selected, start the selection box
+                    if (numsel == 0 && (a_ev->state & GDK_CONTROL_MASK))
+                        ths.m_selecting = true;
                 }
 
-                if ( m_seq->select_events( tick_s, tick_f,
-                            m_status, m_cc, sequence::e_is_selected ))
+                // if event under cursor is selected
+                if ( ths.m_seq->select_events( tick_s, tick_f,
+                            ths.m_status, ths.m_cc, sequence::e_is_selected ))
                 {
 
-                    m_moving_init = true;
-                    int note;
+                    // grab/move the note
+                    if ( !(a_ev->state & GDK_CONTROL_MASK) )
+                    {
+                        ths.m_moving_init = true;
+                        int note;
 
-                    /* get the box that selected elements are in */
-                    m_seq->get_selected_box( &tick_s, &note, 
-                            &tick_f, &note );
+                        /* get the box that selected elements are in */
+                        ths.m_seq->get_selected_box( &tick_s, &note,
+                                &tick_f, &note );
 
-                    tick_f += tick_w;
+                        tick_f += tick_w;
 
-                    /* convert box to X,Y values */
-                    convert_t( tick_s, &x );
-                    convert_t( tick_f, &w );
+                        /* convert box to X,Y values */
+                        ths.convert_t( tick_s, &x );
+                        ths.convert_t( tick_f, &w );
 
-                    /* w is actually corrids now, so we have to change */
-                    w = w-x; 
+                        /* w is actually corrids now, so we have to change */
+                        w = w-x;
 
-                    /* set the m_selected rectangle to hold the
-                       x,y,w,h of our selected events */
+                        /* set the m_selected rectangle to hold the
+                           x,y,w,h of our selected events */
 
-                    m_selected.x = x;                  
-                    m_selected.width=w;
+                        ths.m_selected.x = x;
+                        ths.m_selected.width=w;
 
-                    m_selected.y = (c_eventarea_y - c_eventevent_y)/2;
-                    m_selected.height = c_eventevent_y;
+                        ths.m_selected.y = (c_eventarea_y - c_eventevent_y)/2;
+                        ths.m_selected.height = c_eventevent_y;
 
 
-                    /* save offset that we get from the snap above */
-                    int adjusted_selected_x = m_selected.x;
-                    snap_x( &adjusted_selected_x );
-                    m_move_snap_offset_x = ( m_selected.x - adjusted_selected_x);
+                        /* save offset that we get from the snap above */
+                        int adjusted_selected_x = ths.m_selected.x;
+                        ths.snap_x( &adjusted_selected_x );
+                        ths.m_move_snap_offset_x = ( ths.m_selected.x - adjusted_selected_x);
 
-                    /* align selection for drawing */
-                    snap_x( &m_selected.x );
-                    snap_x( &m_current_x );
-                    snap_x( &m_drop_x );
+                        /* align selection for drawing */
+                        ths.snap_x( &ths.m_selected.x );
+                        ths.snap_x( &ths.m_current_x );
+                        ths.snap_x( &ths.m_drop_x );
+                    }
+                    // ctrl left click when stuff is already selected
+                    else if ((a_ev->state & GDK_CONTROL_MASK) &&
+                             ths.m_seq->select_events( tick_s, tick_f,
+                                                  ths. m_status, ths.m_cc, sequence::e_is_selected ))
+                    {
+                        m_is_drag_pasting_start = true;
+                    }
 
-                } 
+                }
             }
 
         } /* end if button == 1 */
 
-        if ( a_ev->button == 3 ){ 
-
-            set_adding( true );
-        }
-    }
-
-    /* if they clicked, something changed */
-    update_pixmap();
-    draw_pixmap_on_window();  
-
-    return true;
-
-
-}
-
+        if ( a_ev->button == 3 )
+        {
+            /* turn x,y in to tick/note */
+            ths.convert_x( ths.m_drop_x, &tick_s );
 
-void
-seqevent::drop_event( long a_tick )
-{
+            /* shift back a few ticks */
+            tick_f = tick_s + (ths.m_zoom);
+            tick_s -= (tick_w);
 
-    unsigned char status = m_status;
-    unsigned char d0 = m_cc;
-    unsigned char d1 = 0x40;
+            if ( tick_s < 0 )
+                tick_s = 0;
 
-    if ( m_status == EVENT_AFTERTOUCH )
-        d0 = 0;
+            //erase event under cursor if there is one
+            if (ths.m_seq->select_events( tick_s, tick_f,
+                            ths.m_status, ths.m_cc, sequence::e_would_select ))
+            {
+                /* remove only the note under the cursor,
+                   leave the selection intact */
+                ths.m_seq->push_undo();
+                ths.m_seq->select_events( tick_s, tick_f,
+                            ths.m_status, ths.m_cc, sequence::e_remove_one );
+                ths.redraw();
+                ths.m_seq->set_dirty();
+            }
+            else /* selecting */
+            {
+                if  ( ! (a_ev->state & GDK_CONTROL_MASK) )
+                    ths.m_seq->unselect();
 
-    if ( m_status == EVENT_PROGRAM_CHANGE )
-        d0 = 0; /* d0 == new patch */
+                // nothing selected, start the selection box
+                ths.m_selecting = true;
+            }
+        }
+    }
 
-    if ( m_status == EVENT_CHANNEL_PRESSURE )
-        d0 = 0x40; /* d0 == pressure */
+    /* if they clicked, something changed */
+    ths.update_pixmap();
+    ths.draw_pixmap_on_window();
 
-    if ( m_status == EVENT_PITCH_WHEEL )
-        d0 = 0;
+    updateMousePtr( ths );
 
-    m_seq->add_event( a_tick, 
-            status,
-            d0,
-            d1, true );
+    return true;
 }
 
-
-bool 
-seqevent::on_button_release_event(GdkEventButton* a_ev)
+bool FruitySeqEventInput::on_button_release_event(GdkEventButton* a_ev, seqevent& ths)
 {
     long tick_s;
     long tick_f;
